// Sample06.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <malloc.h>
#include <time.h>
#include "..\Lib\Dongle_API.h"
#pragma comment(lib, "..\\LIB\\Dongle_s.lib")

DWORD my_mktime(int add_year = 0, int add_month = 0, int add_day = 0, int add_hour = 0, int add_min = 0, int add_sec = 0)
{
	int  year, mon, day, hour, min, sec;
	long ltime;
    struct tm * ptm;
	//
	time( &ltime );
    ptm = gmtime( &ltime );
	//
	year = ptm->tm_year + 1900 + add_year ;
    mon  = ptm->tm_mon  + 1 + add_month;
	day  = ptm->tm_mday + add_day;
	hour = ptm->tm_hour + add_hour;
	min  = ptm->tm_min  + add_min;
	sec  = ptm->tm_sec  + add_sec;
	//
    if (0 >= (int) (mon -= 2))   // 1..12 -> 11,12,1..10 
	{	
		mon += 12;		// Puts Feb last since it has leap day
		year -= 1;
	}
    //
	return (((
		(year/4 - year/100 + year/400 + 367*mon/12 + day) + year*365 - 719499
		)*24 + hour // now have hours
		)*60 + min    // now have minutes
		)*60 + sec;     // finally seconds
}

int main(int argc, char* argv[])
{
	DWORD dwRet = 0;	
	int nCount = 0;
	int i = 0;
	int nIndex = -1;
	int year,mon,day,hour,min,sec;
	char AdminPin [] = "FFFFFFFFFFFFFFFF";//ĬϿPIN
	int nRemainCount = 0;
	
	time_t tm;
	struct tm *ptm = NULL;
	DWORD dwTime = 0;
	
	DONGLE_HANDLE hDongle = NULL;
	DONGLE_INFO *pDongleInfo = NULL;
	
	//ö
	dwRet = Dongle_Enum(NULL, &nCount);
	printf("Enum %d Dongle ARM. \n", nCount);

	pDongleInfo = (DONGLE_INFO *)malloc(nCount * sizeof(DONGLE_INFO));
	dwRet = Dongle_Enum(pDongleInfo, &nCount);

	for (i = 0; i < nCount; i++)
	{//0xFFʾ׼, 0x00Ϊʱ,0x01ΪʱӵU,0x02Ϊ׼U  
		if (pDongleInfo[i].m_Type == 0 || pDongleInfo[i].m_Type == 1)
		{
			nIndex = i;
		}
	}

	if (nIndex == -1)
	{//ûҵʱ
		printf("Can't Find Time Dongle ARM.\n");
		Dongle_Close(hDongle);
		return 0;
	}
	
	//
	dwRet = Dongle_Open(&hDongle, 0);
	printf("Open Dongle ARM. Return : 0x%08X . \n", dwRet);
	
	//֤PIN
	dwRet = Dongle_VerifyPIN(hDongle, FLAG_ADMINPIN, AdminPin, &nRemainCount);
	printf("Verify Admin PIN. Return: 0x%08X\n", dwRet);


	//ȡʱ
	dwRet = Dongle_GetUTCTime(hDongle, &dwTime);
	printf("Get UTC Time. Return: 0x%08X\n", dwRet);

	if (DONGLE_SUCCESS == dwRet)
	{
		ptm = gmtime((const time_t *)&dwTime);
		//תΪʱ
		year = ptm->tm_year + 1900;
		mon  = ptm->tm_mon + 1;
		day  = ptm->tm_mday;
		hour = ptm->tm_hour;
		min  = ptm->tm_min;
		sec  = ptm->tm_sec;
		printf("Date: %04d-%02d-%02d %02d:%02d:%02d \n", year, mon, day, hour, min, sec);
	}

	//õʱ乲ַʽ
	//1.СʱУûPIN֮ʼʱ
	dwTime = 24;//ʹ24СʱdwTimeȡֵΧΪ1~65535
	dwRet = Dongle_SetDeadline(hDongle, dwTime);
	printf("1.Set Deadline [hour] time. Return: 0x%08X\n", dwRet);

	//2.
	dwTime = my_mktime(1);//ȡڿʼ㣬1utcʱ䡣UTCֵ65535
	dwRet = Dongle_SetDeadline(hDongle, dwTime);
	printf("2.Set Deadline [date] time. Return: 0x%08X\n", dwRet);

	//3.ȡʱ
	dwTime = 0xFFFFFFFF;//ȡʱ
	dwRet = Dongle_SetDeadline(hDongle, dwTime);
	printf("3.Cancel Deadline time. Return: 0x%08X\n", dwRet);

	//ȡʱ
	dwTime = 0;
	dwRet = Dongle_GetDeadline(hDongle, &dwTime);
	printf("Get Deadline time. Return: 0x%08X\n", dwRet);

	if (DONGLE_SUCCESS == dwRet)
	{
		if (dwRet == 0xFFFFFFFF)
		{
			printf("Unlimited time. \n");
		}
		
		if ((dwRet & 0xFFFF0000) == 0)
		{//Сʱ
			printf("Limit hour: %d", dwRet);
		}
		else
		{//
			tm = (time_t)dwTime;
			ptm = gmtime(&tm);
			year = ptm->tm_year + 1900;
			mon  = ptm->tm_mon + 1;
			day  = ptm->tm_mday;
			hour = ptm->tm_hour;
			min  = ptm->tm_min;
			sec  = ptm->tm_sec;
			printf("Deadline: %04d-%02d-%02d %02d:%02d:%02d \n", year, mon, day, hour, min, sec);
		}
	}

	//رռ
	dwRet = Dongle_Close(hDongle);
	printf("Close Dongle ARM. Return: 0x%08X\n", dwRet);

	if (pDongleInfo != NULL)
	{
		free(pDongleInfo);
		pDongleInfo = NULL;
	}

	return 0;
}

