// Sample09.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "..\Lib\Dongle_API.h"
#pragma comment(lib, "..\\LIB\\Dongle_s.lib")

int main(int argc, char* argv[])
{
	DWORD dwRet = 0;	
	int nCount = 0;
	int i = 0;
	char AdminPin [] = "FFFFFFFFFFFFFFFF";//ĬϿPIN
	int nRemainCount = 0;
	
	DONGLE_HANDLE hDongle = NULL;
	ECCSM2_PUBLIC_KEY  eccPub; //ECCԿSM2Կṹͬ
	ECCSM2_PRIVATE_KEY eccPri; //ECC˽ԿSM2˽Կṹͬ
	PRIKEY_FILE_ATTR priAttr;
	WORD wPriID = 0x1111;
	
	FILE *fp = NULL;
	int nLen = 0;
	BYTE pSign[64]; //ǩݹ̶64ֽ
	BYTE pHash[24]; //192λĲ24ֽڣ256λĲ32ֽ
	int  nHashData = 24;
	
	for (i = 0; i < 24; i++) pHash[i] = i;

	//ö
	dwRet = Dongle_Enum(NULL, &nCount);
	printf("Enum %d Dongle ARM. \n", nCount);
	
	//
	dwRet = Dongle_Open(&hDongle, 0);
	printf("Open Dongle ARM. Return : 0x%08X . \n", dwRet);
	
	//֤PIN
	dwRet = Dongle_VerifyPIN(hDongle, FLAG_ADMINPIN, AdminPin, &nRemainCount);
	printf("Verify Admin PIN. Return: 0x%08X\n", dwRet);

	//ECC˽Կ
	priAttr.m_Size = 192;//Ҳ256
	priAttr.m_Type = FILE_PRIKEY_RSA;
	priAttr.m_Lic.m_Count =0xFFFFFFFF;//ɵô
	priAttr.m_Lic.m_IsDecOnRAM = FALSE;//ǷΪڴеݼ
	priAttr.m_Lic.m_IsReset = FALSE;//Ƿָ̬
	priAttr.m_Lic.m_Priv = 0;//ɵõСȨ
	
	dwRet = Dongle_CreateFile(hDongle, FILE_PRIKEY_ECCSM2, wPriID, (void*)&priAttr);
	printf("Create ECC private key file. Return: 0x%08X\n", dwRet);
	if (DONGLE_SUCCESS != dwRet)
	{
		return 0;
	}

	//ECC˽Կ
	dwRet = Dongle_EccGenPubPriKey(hDongle, wPriID, &eccPub, &eccPri);
	printf("Gen ECC Public key and private key. Return: 0x%08X\n", dwRet);
	if (DONGLE_SUCCESS != dwRet)
	{
		return 0;
	}
	
	//ECC˽Կ
	fp = fopen("1111.EccSm2pub", "wb");
	fwrite(&eccPub, 1, sizeof(ECCSM2_PUBLIC_KEY), fp);
	fclose(fp);
	
	fp = fopen("1111.EccSm2pri", "wb");
	fwrite(&eccPri, 1, sizeof(ECCSM2_PRIVATE_KEY), fp);
	fclose(fp);
	fp = NULL;

	//ECC˽Կǩ
	dwRet = Dongle_EccSign(hDongle, wPriID, pHash, nHashData, pSign);
	printf("ECC private key sign. Return: 0x%08X\n", dwRet);


	//ECCԿǩ
	dwRet = Dongle_EccVerify(hDongle, &eccPub, pHash, nHashData, pSign);
	if (DONGLE_SUCCESS == dwRet)
	{
		printf("ECC public key verify success. \n");
	}
	else
	{
		printf("ECC public key verify failed. \n");
	}

	//ɾECC˽Կ
	dwRet = Dongle_DeleteFile(hDongle, FILE_PRIKEY_ECCSM2, wPriID);
	printf("Delete ECC private key file. Return: 0x%08X\n", dwRet);
	
	//رռ
	dwRet = Dongle_Close(hDongle);
	printf("Close Dongle ARM. Return: 0x%08X\n", dwRet);

	return 0;
}

